# -*- mode: rpm-spec; indent-tabs-mode: nil -*-
#========================================================================
%global debug_package %{nil}

%define    ldastoolsal_swig_ver      2.6.8
%define    basename_ver         2.7.2
%define    basename_   ldas-tools-framecpp
%define    name        %{basename_}-swig
%define    name_desc   frameCPP
%define    hdr_dir     framecpp
%define    tarbasename ldas-tools-framecpp-swig
%define    version     2.6.11
%define    release     1
%define    _docdir     %{_datadir}/doc/%{name}-%{version}

#------------------------------------------------------------------------
# OS configuration
#------------------------------------------------------------------------
%if 0%{?rhel} != 0
%if 0%{?rhel} <= 7
%define cmake_package cmake3 >= 3.6, cmake
%endif

%endif # 0%{?rhel}

%if 0%{?centos:1}
%if 0%{?centos} <= 7
%define cmake_package cmake3 >= 3.6, cmake
%define swig_package swig3 >= 
%endif
%endif

#------------------------------------------------------------------------
# Defaults
#------------------------------------------------------------------------

%if 0%{!?swig_package:1}
%define swig_package swig >= 
%endif
%if 0%{!?cmake_package:1}
%define cmake_package cmake >= 3.6
%endif

%if %{?__python2:1}%{!?__ptyhon2:0}
%define    python_build_opts  -DENABLE_SWIG_PYTHON2=yes -DPYTHON2_EXECUTABLE=%{__python2}
%else
%define    python_build_opts  -DENABLE_SWIG_PYTHON2=NO
%endif
%if %{?__python3:1}%{!?__ptyhon3:0}
%define    python3_build_opts -DENABLE_SWIG_PYTHON3=YES -DPYTHON3_EXECUTABLE=%{__python3}
%else
%define    python_build_opts  -DENABLE_SWIG_PYTHON3=NO
%endif

%if %{?cmake3:1}%{!?cmake3:0}
%define cmake cmake3
%define ctest ctest3
%endif

#------------------------------------------------------------------------
Name:      %{name}
Summary:   SWIG bindings for LDAS Tools frameCPP library
Version:   %{version}
Release:   %{release}%{?dist}
License:   GPLv2+
URL:       "https://wiki.ligo.org/Computing/LDASTools"
Group:     Application/Scientific
Provides:  %{name} = %{version}
Obsoletes: %{name} < %{version}
Conflicts: %{basename_}-devel < 2.6.0
Prefix:    %_prefix
BuildRoot: %{buildroot}
Source0:   https://software.igwn.org/lscsoft/source/%{tarbasename}-%{version}.tar.gz

#------------------------------------------------------------------------
BuildRequires: %{cmake_package}
BuildRequires: python3-rpm-macros
BuildRequires: gawk
BuildRequires: gcc, gcc-c++, glibc
BuildRequires: make
Buildrequires: ldas-tools-cmake >= 1.2.2
Buildrequires: %{basename_}-devel >= 2.7.2
Buildrequires: pkgconfig
BuildRequires: rpm-build
Buildrequires: swig
#........................................................................
# Python dependencies
#........................................................................
BuildRequires: python
BuildRequires: python-devel
BuildRequires: numpy
BuildRequires: python2-ldas-tools-al >= 2.6.8
#........................................................................
# Python 3 dependencies
#........................................................................
BuildRequires: python3
BuildRequires: python3-libs
BuildRequires: python3-devel
BuildRequires: python%{python3_pkgversion}-numpy
BuildRequires: python%{python3_pkgversion}-ldas-tools-al >= 2.6.8
#........................................................................
# Runtime dependencies
#........................................................................
Requires: swig
Requires: %{basename_}-devel >= 2.7.2

%description


#========================================================================
%package -n python2-%{basename_}
Summary: LDAS Tools %{name_desc} toolkit python %{python_version} bindings
#........................................................................
# Runtime dependencies
#........................................................................
Requires: python2-ldas-tools-al >= %{ldastoolsal_swig_ver}
Requires: %{basename_} >= %{basename_ver}
Requires: numpy
Obsoletes: %{basename_}-python < 2.6.0

%description -n  python2-%{basename_}
This provides the python%{python_version} bindings for the %{name_desc} library

#========================================================================
%package -n python%{python3_pkgversion}-%{basename_}
Summary: LDAS Tools %{name_desc} toolkit python %{python3_version} bindings
#........................................................................
# Runtime dependencies
#........................................................................
Requires: python%{python3_pkgversion}-ldas-tools-al >= %{ldastoolsal_swig_ver}
Requires: %{basename_} >= %{basename_ver}
Requires: python%{python3_pkgversion}-numpy

%description -n  python%{python3_pkgversion}-%{basename_}
This provides the python%{python3_version} bindings for the %{name_desc} library

%prep
%setup -c -T -D -a 0 -n %{name}-%{version}

%build
%cmake \
    %{python_build_opts} \
    %{python3_build_opts} \
    -DCMAKE_BUILD_TYPE=RelWithDebInfo -DCMAKE_EXPORT_COMPILE_COMMANDS=1 \
    -DCMAKE_INSTALL_PREFIX=%{_prefix} \
    -DCMAKE_INSTALL_DOCDIR=%{_docdir} \
    %{tarbasename}-%{version}

%install
make install DESTDIR=%{buildroot}

%check
%ctest -V %{?_smp_mflags}

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%{_includedir}/%{hdr_dir}

%files -n python2-%{basename_}
%defattr(-,root,root,-)
%{_libdir}/python2*
%{_bindir}/py2*

%files -n python%{python3_pkgversion}-%{basename_}
%defattr(-,root,root,-)
%{_libdir}/python3*
%{_bindir}/py3*

%changelog
* Fri Aug 13 2021 Edward Maros <ed.maros@ligo.org> - 2.6.11-1
- Built for new release

* Tue Mar 9 2021 Edward Maros <ed.maros@ligo.org> - 2.6.10-1
- Built for new release

* Wed Aug 14 2019 Edward Maros <ed.maros@ligo.org> - 2.6.9-1
- Built for new release

* Sat Feb 02 2019 Edward Maros <ed.maros@ligo.org> - 2.6.8-1
- Built for new release

* Tue Jan 08 2019 Edward Maros <ed.maros@ligo.org> - 2.6.7-1
- Built for new release

* Thu Dec 06 2018 Edward Maros <ed.maros@ligo.org> - 2.6.6-1
- Built for new release

* Tue Oct 11 2011 Edward Maros <emaros@ligo.caltech.edu> - 1.19.13-1
- Initial build.
